Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/Makefile_chem_gasphase_mod
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/Makefile_chem_gasphase_mod	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/Makefile_chem_gasphase_mod	(revision 2696)
@@ -0,0 +1,178 @@
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# User: Set here the F90 compiler and options
+#       Pedefined compilers: INTEL, PGF, HPUX, LAHEY
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+#COMPILER = G95
+#COMPILER = LAHEY
+COMPILER = INTEL
+#COMPILER = PGF
+#COMPILER = HPUX
+#COMPILER = GFORTRAN
+
+FC_G95     = g95
+FOPT_G95   = -cpp -O -pg -fbounds-check -fimplicit-none  -Wall -ftrace=full
+
+FC_LAHEY   = lf95
+# More aggressive for production runs:
+#FOPT_LAHEY = -Cpp --pca -O
+# More checking for debugging:
+FOPT_LAHEY = -Cpp --chk a,e,s,u --pca --ap -O0 -g --trap --trace --chkglobal
+
+FC_INTEL   = ifort 
+# More aggressive for production runs:
+#FOPT_INTEL = -cpp -O -fp-model precise -pc80 -prec_div
+# More checking for debugging:
+FOPT_INTEL = -cpp -O0 -fp-model strict -implicitnone -ftrapuv \
+              -debug all -check all -warn all
+
+FC_PGF     = pgf90
+# More aggressive for production runs:
+FOPT_PGF   = -Mpreprocess -O -fast -pc 80 -Kieee
+# More checking for debugging:
+#FOPT_PGF   = -Mpreprocess -O0 -Mbounds -Mchkfpstk -Mchkptr -Mchkstk \
+#             -Ktrap=fp -pc 80 -Kieee
+
+FC_HPUX    = f90
+FOPT_HPUX  = -O -u +Oall +check=on
+
+FC_GFORTRAN     = gfortran
+FOPT_GFORTRAN   = -cpp -O
+
+# define FULL_ALGEBRA for non-sparse integration
+FC   = $(FC_$(COMPILER))
+FOPT = $(FOPT_$(COMPILER)) # -DFULL_ALGEBRA
+
+LIBS =
+#LIBS = -llapack -lblas
+
+# Command to create Matlab mex gateway routines 
+# Note: use $(FC) as the mex Fortran compiler
+MEX  = mex
+
+GENSRC = chem_gasphase_mod_Precision.f90  \
+	 chem_gasphase_mod_Parameters.f90     \
+	 chem_gasphase_mod_Global.f90  
+
+GENOBJ = chem_gasphase_mod_Precision.o    \
+	 chem_gasphase_mod_Parameters.o       \
+	 chem_gasphase_mod_Global.o     
+
+FUNSRC = chem_gasphase_mod_Function.f90 
+FUNOBJ = chem_gasphase_mod_Function.o 
+
+JACSRC = chem_gasphase_mod_JacobianSP.f90  chem_gasphase_mod_Jacobian.f90
+JACOBJ = chem_gasphase_mod_JacobianSP.o    chem_gasphase_mod_Jacobian.o
+
+HESSRC = chem_gasphase_mod_HessianSP.f90   chem_gasphase_mod_Hessian.f90
+HESOBJ = chem_gasphase_mod_HessianSP.o     chem_gasphase_mod_Hessian.o
+
+STMSRC = chem_gasphase_mod_StoichiomSP.f90 chem_gasphase_mod_Stoichiom.f90 
+STMOBJ = chem_gasphase_mod_StoichiomSP.o   chem_gasphase_mod_Stoichiom.o
+
+UTLSRC = chem_gasphase_mod_Rates.f90 chem_gasphase_mod_Util.f90 chem_gasphase_mod_Monitor.f90
+UTLOBJ = chem_gasphase_mod_Rates.o   chem_gasphase_mod_Util.o   chem_gasphase_mod_Monitor.o
+
+LASRC  = chem_gasphase_mod_LinearAlgebra.f90 
+LAOBJ  = chem_gasphase_mod_LinearAlgebra.o   
+
+STOCHSRC = chem_gasphase_mod_Stochastic.f90 
+STOCHOBJ = chem_gasphase_mod_Stochastic.o 
+
+MAINSRC = chem_gasphase_mod_Main.f90   chem_gasphase_mod_Initialize.f90   chem_gasphase_mod_Integrator.f90 chem_gasphase_mod_Model.f90
+MAINOBJ = chem_gasphase_mod_Main.o     chem_gasphase_mod_Initialize.o     chem_gasphase_mod_Integrator.o   chem_gasphase_mod_Model.o 
+
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# User: modify the line below to include only the
+#       objects needed by your application
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ALLOBJ = $(GENOBJ) $(FUNOBJ) $(JACOBJ) $(HESOBJ) $(STMOBJ) \
+	 $(UTLOBJ) $(LAOBJ)
+
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# User: modify the line below to include only the
+#       executables needed by your application
+#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+all:    exe
+
+exe:	$(ALLOBJ) $(MAINOBJ) 
+	$(FC) $(FOPT) $(ALLOBJ) $(MAINOBJ) $(LIBS) -o chem_gasphase_mod.exe
+
+stochastic:$(ALLOBJ) $(STOCHOBJ) $(MAINOBJ)
+	$(FC) $(FOPT) $(ALLOBJ) $(STOCHOBJ) $(MAINOBJ) $(LIBS) \
+	-o chem_gasphase_mod_stochastic.exe
+
+mex:    $(ALLOBJ)
+	$(MEX) FC#$(FC) -fortran -O chem_gasphase_mod_mex_Fun.f90     $(ALLOBJ)
+	$(MEX) FC#$(FC) -fortran -O chem_gasphase_mod_mex_Jac_SP.f90  $(ALLOBJ)
+	$(MEX) FC#$(FC) -fortran -O chem_gasphase_mod_mex_Hessian.f90 $(ALLOBJ)
+
+clean:
+	rm -f chem_gasphase_mod*.o chem_gasphase_mod*.mod \
+	chem_gasphase_mod*.dat chem_gasphase_mod.exe chem_gasphase_mod*.mexglx \
+	chem_gasphase_mod.map
+
+distclean:
+	rm -f chem_gasphase_mod*.o chem_gasphase_mod*.mod \
+	chem_gasphase_mod*.dat chem_gasphase_mod.exe chem_gasphase_mod.map \
+	chem_gasphase_mod*.f90 chem_gasphase_mod_*.mexglx
+
+chem_gasphase_mod_Precision.o: chem_gasphase_mod_Precision.f90 
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Parameters.o: chem_gasphase_mod_Parameters.f90 \
+	            chem_gasphase_mod_Precision.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Monitor.o: chem_gasphase_mod_Monitor.f90 \
+	             chem_gasphase_mod_Precision.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Global.o: chem_gasphase_mod_Global.f90 \
+	            chem_gasphase_mod_Parameters.o chem_gasphase_mod_Precision.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Initialize.o: chem_gasphase_mod_Initialize.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Function.o: chem_gasphase_mod_Function.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Stochastic.o: chem_gasphase_mod_Stochastic.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_JacobianSP.o: chem_gasphase_mod_JacobianSP.f90 $(GENOBJ)
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Jacobian.o: chem_gasphase_mod_Jacobian.f90  $(GENOBJ) chem_gasphase_mod_JacobianSP.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_LinearAlgebra.o: chem_gasphase_mod_LinearAlgebra.f90 $(GENOBJ) chem_gasphase_mod_JacobianSP.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Rates.o: chem_gasphase_mod_Rates.f90  $(GENOBJ) 
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_HessianSP.o: chem_gasphase_mod_HessianSP.f90  $(GENOBJ)
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Hessian.o:  chem_gasphase_mod_Hessian.f90 $(GENOBJ) chem_gasphase_mod_HessianSP.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_StoichiomSP.o: chem_gasphase_mod_StoichiomSP.f90 $(GENOBJ)
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Stoichiom.o: chem_gasphase_mod_Stoichiom.f90  $(GENOBJ) chem_gasphase_mod_StoichiomSP.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Util.o: chem_gasphase_mod_Util.f90  $(GENOBJ) chem_gasphase_mod_Monitor.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Main.o: chem_gasphase_mod_Main.f90  $(ALLOBJ) chem_gasphase_mod_Initialize.o chem_gasphase_mod_Model.o chem_gasphase_mod_Integrator.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Model.o: chem_gasphase_mod_Model.f90  $(ALLOBJ) chem_gasphase_mod_Integrator.o
+	$(FC) $(FOPT) -c $<
+
+chem_gasphase_mod_Integrator.o: chem_gasphase_mod_Integrator.f90  $(ALLOBJ)
+	$(FC) $(FOPT) -c $<
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod.kpp
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod.kpp	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod.kpp	(revision 2696)
@@ -0,0 +1,36 @@
+//chem_gasphase_mod.kpp
+//
+//Former revisions
+//----------------
+// $Id: chem_gasphase_mod.kpp 2459 2017-09-13 14:10:33Z forkel $
+//
+#include      passive.spc
+#include      passive.eqn
+#INTEGRATOR rosenbrock
+#LANGUAGE   Fortran90
+#HESSIAN    on
+#STOICMAT   on
+#INLINE F90_GLOBAL
+  !   Declaration of global variable declarations for photolysis will come from INLINE F90_DATA
+#ENDINLINE
+//
+// *******************************************************************************************
+// *** adapt the lines below occurding to the photolysis reactions of your mechanism         *
+// *** adapt the number of photolysis frequencies NPHO                                       *
+// *** adapt/extend the indices in the INTEGER, PARAMETER,PUBLIC statement below             *
+// *** adapt/extend PHOT_NAMES: Note that the order of PHOT_NAMES and the indices must match *
+// *******************************************************************************************
+//
+#INLINE F90_DATA
+  !   INLINE F90_DATA: Declaration of global variables for photolysis
+  !   REAL(kind=dp) :: phot(nphot) must eventually be moved to GLOBAL later for vector version
+  INTEGER, PARAMETER :: nphot = 1
+  !   phot Photolysis frequencies
+  REAL(kind=dp) :: phot(nphot)
+
+  INTEGER, PARAMETER,PUBLIC :: j_no2 = 1
+
+  CHARACTER(LEN=15), PARAMETER, DIMENSION(NPHOT) :: phot_names =  (/ &
+     'J_NO2          '/)
+#ENDINLINE
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_Model.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_Model.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_Model.f90	(revision 2696)
@@ -0,0 +1,22 @@
+MODULE chem_gasphase_mod_Model
+
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  Completely defines the model chem_gasphase_mod
+!    by using all the associated modules
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE chem_gasphase_mod_Precision
+  USE chem_gasphase_mod_Parameters
+  USE chem_gasphase_mod_Global
+  USE chem_gasphase_mod_Function
+  USE chem_gasphase_mod_Integrator
+  USE chem_gasphase_mod_Rates
+  USE chem_gasphase_mod_Jacobian
+  USE chem_gasphase_mod_Hessian
+  USE chem_gasphase_mod_Stoichiom
+  USE chem_gasphase_mod_LinearAlgebra
+  USE chem_gasphase_mod_Monitor
+  USE chem_gasphase_mod_Util
+
+END MODULE chem_gasphase_mod_Model
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_Precision.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_Precision.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_Precision.f90	(revision 2696)
@@ -0,0 +1,17 @@
+
+MODULE chem_gasphase_mod_Precision
+
+!
+! Definition of different levels of accuracy
+! for REAL variables using KIND parameterization
+!
+! KPP SP - Single precision kind
+  INTEGER, PARAMETER :: sp = SELECTED_REAL_KIND(6,30)
+! KPP DP - Double precision kind
+  INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(14,300)
+! KPP QP - Quadruple precision kind
+  INTEGER, PARAMETER :: qp = SELECTED_REAL_KIND(18,400)
+
+END MODULE chem_gasphase_mod_Precision
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Fun.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Fun.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Fun.f90	(revision 2696)
@@ -0,0 +1,45 @@
+
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ SUBROUTINE mexFunction( nlhs, plhs, nrhs, prhs )
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!                 Matlab Gateway for the Derivative Function Fun
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+ USE chem_gasphase_mod_Model
+
+      INTEGER nlhs, nrhs
+      INTEGER plhs(*), prhs(*)
+      INTEGER mxGetPr, mxCreateFull, mxGetM, mxgetN
+      INTEGER VPtr, FPtr, RPtr, VdotPtr
+      REAL(kind=dp) V(3), F(0), RCT(3)
+      REAL(kind=dp) Vdot(3)
+
+! Check for the right number of input arguments
+      IF ( nrhs .ne. 3 ) THEN
+         CALL mexErrMsgTxt('Fun requires 3 input vectors: &
+     &V(3), F(0), RCT(3)')
+      END IF 
+! Check for the right number of output arguments
+      IF ( nlhs .ne. 1 ) THEN
+         CALL mexErrMsgTxt('Fun requires 1 output vector: &
+     &Vdot(3)')
+      END IF 
+
+      plhs(1) = mxCreateDoubleMatrix(3,1,0)
+
+      VPtr = mxGetPr(prhs(1))
+      CALL mxCopyPtrToReal8(VPtr,V,3)
+      
+      FPtr = mxGetPr(prhs(2))
+      CALL mxCopyPtrToReal8(FPtr,F,0)
+      
+      RPtr = mxGetPr(prhs(3))
+      CALL mxCopyPtrToReal8(RPtr,RCT,3)
+
+      VdotPtr = mxGetPr(plhs(1))
+
+      CALL Fun( V, F, RCT, Vdot )
+
+      CALL mxCopyReal8ToPtr(Vdot, VdotPtr, 3)
+
+ END SUBROUTINE mexFunction
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Hessian.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Hessian.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Hessian.f90	(revision 2696)
@@ -0,0 +1,45 @@
+
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ SUBROUTINE mexFunction( nlhs, plhs, nrhs, prhs )
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!                  Matlab Gateway for the Function Hessian
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+ USE chem_gasphase_mod_Model
+
+      INTEGER nlhs, nrhs
+      INTEGER plhs(*), prhs(*)
+      INTEGER mxGetPr, mxCreateFull, mxGetM, mxgetN
+      INTEGER VPtr, FPtr, RPtr, HESSPtr
+      REAL(kind=dp) V(3), F(0), RCT(3)
+      REAL(kind=dp) HESS(0)
+
+! Check for the right number of input arguments
+      IF ( nrhs .ne. 3 ) THEN
+         CALL mexErrMsgTxt('Hessian requires 3 input vectors: &
+     &V(3), F(0), RCT(3)')
+      END IF 
+! Check for the right number of output arguments
+      IF ( nlhs .ne. 1 ) THEN
+         CALL mexErrMsgTxt('Hessian requires 1 output vector: &
+     &HESS(0)')
+      END IF 
+
+      plhs(1) = mxCreateDoubleMatrix(0,1,0)
+
+      VPtr = mxGetPr(prhs(1));
+      CALL mxCopyPtrToReal8(VPtr,V,3)
+      
+      FPtr = mxGetPr(prhs(2));
+      CALL mxCopyPtrToReal8(FPtr,F,0)
+      
+      RPtr = mxGetPr(prhs(3));
+      CALL mxCopyPtrToReal8(RPtr,RCT,3)
+
+      HESSPtr = mxGetPr(plhs(1))
+
+      CALL Hessian( V, F, RCT, HESS )
+
+      CALL mxCopyReal8ToPtr(HESS, HESSPtr, 0)
+
+ END SUBROUTINE mexFunction
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Jac_SP.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Jac_SP.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/chem_gasphase_mod_mex_Jac_SP.f90	(revision 2696)
@@ -0,0 +1,44 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ SUBROUTINE mexFunction( nlhs, plhs, nrhs, prhs )
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!          Matlab Gateway for the Sparse Jacobian Function Jac_SP
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+ USE chem_gasphase_mod_Model
+
+      INTEGER nlhs, nrhs
+      INTEGER plhs(*), prhs(*)
+      INTEGER mxGetPr, mxCreateFull, mxGetM, mxgetN
+      INTEGER VPtr, FPtr, RPtr, JVSPtr
+      REAL(kind=dp) V(3), F(0), RCT(3)
+      REAL(kind=dp) JVS(3)
+
+! Check for the right number of input arguments
+      IF ( nrhs .ne. 3 ) THEN
+         CALL mexErrMsgTxt('Jac_SP requires 3 input vectors: &
+     &V(3), F(0), RCT(3)')
+      END IF 
+! Check for the right number of output arguments
+      IF ( nlhs .ne. 1 ) THEN
+         CALL mexErrMsgTxt('Jac_SP requires 1 output vector: &
+     &JVS(3)')
+      END IF 
+
+      plhs(1) = mxCreateDoubleMatrix(3,1,0)
+
+      VPtr = mxGetPr(prhs(1))
+      CALL mxCopyPtrToReal8(VPtr,V,3)
+      
+      FPtr = mxGetPr(prhs(2))
+      CALL mxCopyPtrToReal8(FPtr,F,0)
+      
+      RPtr = mxGetPr(prhs(3))
+      CALL mxCopyPtrToReal8(RPtr,RCT,3)
+
+      JVSPtr = mxGetPr(plhs(1))
+
+      CALL Jac_SP( V, F, RCT, JVS )
+
+      CALL mxCopyReal8ToPtr(JVS, JVSPtr, 3)
+
+ END SUBROUTINE mexFunction
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/file_list
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/file_list	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/file_list	(revision 2696)
@@ -0,0 +1,8 @@
+chem_gasphase_mod_Initialize
+chem_gasphase_mod_Integrator
+chem_gasphase_mod_LinearAlgebra
+chem_gasphase_mod_Jacobian
+chem_gasphase_mod_Function
+chem_gasphase_mod_Rates
+chem_gasphase_mod_Util
+initialize_kpp_ctrl_template
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/include_list
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/include_list	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/include_list	(revision 2696)
@@ -0,0 +1,4 @@
+chem_gasphase_mod_Parameters
+chem_gasphase_mod_Global
+chem_gasphase_mod_JacobianSP
+chem_gasphase_mod_Monitor
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/initialize_kpp_ctrl_template.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/initialize_kpp_ctrl_template.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/initialize_kpp_ctrl_template.f90	(revision 2696)
@@ -0,0 +1,100 @@
+MODULE initialize_kpp_ctrl_template
+
+  ! HEADER MODULE initialize_kpp_ctrl_template
+
+  ! NOTES:
+  ! - L_VECTOR is automatically defined by kp4
+  ! - VL_DIM is automatically defined by kp4
+  ! - I_LU_DI is automatically defined by kp4
+  ! - WANTED is automatically defined by xmecca
+  ! - ICNTRL RCNTRL are automatically defined by kpp
+  ! - "USE messy_main_tools" is in Module_header of messy_mecca_kpp.f90
+  ! - SAVE will be automatically added by kp4
+
+  IMPLICIT NONE
+  !SAVE
+
+  ! FOR FIXED TIME STEP CONTROL
+  ! ... max. number of fixed time steps (sum must be 1)
+  INTEGER, PARAMETER         :: NMAXFIXSTEPS = 50
+  ! ... switch for fixed time stepping
+  LOGICAL, PUBLIC            :: l_fixed_step = .FALSE.
+  INTEGER, PUBLIC            :: nfsteps = 1
+  ! ... number of kpp control parameters
+  INTEGER, PARAMETER, PUBLIC :: NKPPCTRL = 20
+  !
+  INTEGER,  DIMENSION(NKPPCTRL), PUBLIC     :: icntrl = 0
+  REAL(DP), DIMENSION(NKPPCTRL), PUBLIC     :: rcntrl = 0.0_dp
+  REAL(DP), DIMENSION(NMAXFIXSTEPS), PUBLIC :: t_steps = 0.0_dp
+
+  ! END HEADER MODULE initialize_kpp_ctrl_template
+
+CONTAINS
+
+SUBROUTINE initialize_kpp_ctrl(status, iou, modstr)
+
+  IMPLICIT NONE
+
+  ! I/O
+  INTEGER,          INTENT(OUT) :: status
+  INTEGER,          INTENT(IN)  :: iou     ! logical I/O unit
+  CHARACTER(LEN=*), INTENT(IN)  :: modstr  ! read <modstr>.nml
+
+  ! LOCAL
+  REAL(DP) :: tsum
+  INTEGER  :: i
+
+  ! check fixed time steps
+  tsum = 0.0_dp
+  DO i=1, NMAXFIXSTEPS
+     IF (t_steps(i) < TINY(0.0_DP)) EXIT
+     tsum = tsum + t_steps(i)
+  END DO
+
+  nfsteps = i-1
+
+  l_fixed_step = (nfsteps > 0) .AND. ( (tsum -1.0) < TINY(0.0_DP) )
+
+  IF (L_VECTOR) THEN
+     WRITE(*,*) ' MODE             : VECTOR (LENGTH=',VL_DIM,')'
+  ELSE
+     WRITE(*,*) ' MODE             : SCALAR'
+  END IF
+  !
+  WRITE(*,*) ' DE-INDEXING MODE :',I_LU_DI
+  !
+  WRITE(*,*) ' ICNTRL           : ',icntrl
+  WRITE(*,*) ' RCNTRL           : ',rcntrl
+  !
+  ! NOTE: THIS IS ONLY MEANINGFUL FOR VECTORIZED (kp4) ROSENBROCK-METHODS
+  IF (L_VECTOR) THEN
+     IF (l_fixed_step) THEN
+        WRITE(*,*) ' TIME STEPS       : FIXED (',t_steps(1:nfsteps),')'
+     ELSE
+        WRITE(*,*) ' TIME STEPS       : AUTOMATIC'
+     END IF
+  ELSE
+     WRITE(*,*) ' TIME STEPS       : AUTOMATIC '//&
+          &'(t_steps (CTRL_KPP) ignored in SCALAR MODE)'
+  END IF
+  ! mz_pj_20070531-
+
+  status = 0
+
+
+END SUBROUTINE initialize_kpp_ctrl
+
+SUBROUTINE error_output(C,ierr,PE)
+
+  IMPLICIT NONE
+
+  INTEGER, INTENT(IN) :: ierr
+  INTEGER, INTENT(IN) :: PE
+  REAL(dp), DIMENSION(:),INTENT(IN) :: C
+
+  write(6,*) 'ERROR in chem_gasphase_mod ',ierr,C(1)
+
+
+END SUBROUTINE error_output
+
+END MODULE initialize_kpp_ctrl_template
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/interface_ignore_list
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/interface_ignore_list	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/interface_ignore_list	(revision 2696)
@@ -0,0 +1,2 @@
+waxpy
+wcopy
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/passive.eqn
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/passive.eqn	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/passive.eqn	(revision 2696)
@@ -0,0 +1,12 @@
+{passive.eqn
+Former revisions
+----------------
+ $Id$
+}
+#EQUATIONS
+
+{ passive: does nothing }
+
+  { 1.}  CO = CO :                       1.0_wp  ;
+  { 1.}  PM10 = PM10 :                   1.0_wp  ;
+  { 1.}  PM25 = PM25 :                   1.0_wp  ;
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/passive.spc
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/passive.spc	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/passive.spc	(revision 2696)
@@ -0,0 +1,21 @@
+{passive.spc
+Former revisions
+----------------
+ $Id$
+}
+#include atoms
+
+ #DEFVAR
+    CO      = C + O ;       {carbon monoxide}
+
+    PM10    = ignore ;
+    PM25    = ignore ;
+
+#DEFFIX
+    H2O         = H + 2O ;      {water}
+    H2          = 2H ;          {molecular hydrogen}
+    O2      = 2O ;          {molecular oxygen}
+    N2      = 2N ;          {molecular nitrogen}
+    CH4         = C + 4H ;      {methane}
+    CO2     = C + 2O ;      {carbon dioxide}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/subroutine_list
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/subroutine_list	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm/subroutine_list	(revision 2696)
@@ -0,0 +1,19 @@
+initialize
+integrate
+fun
+kppsolve
+kppdecomp
+wlamch
+wlamch_add
+jac_sp
+k_arr
+update_rconst
+arr2
+initialize_kpp_ctrl
+error_output
+wcopy
+wscal
+waxpy
+rosenbrock
+funtemplate
+jactemplate
Index: palm/trunk/UTIL/combine_plot_fields.f90
===================================================================
--- palm/trunk/UTIL/combine_plot_fields.f90	(revision 2693)
+++ palm/trunk/UTIL/combine_plot_fields.f90	(revision 2696)
@@ -2,9 +2,10 @@
 
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms
-! of the GNU General Public License as published by the Free Software Foundation,
-! either version 3 of the License, or (at your option) any later version.
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
 !
 ! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
@@ -15,6 +16,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014  Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! Copyright 1997-2017  Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
Index: palm/trunk/UTIL/combine_plot_fields_single_open.f90
===================================================================
--- palm/trunk/UTIL/combine_plot_fields_single_open.f90	(revision 2693)
+++ palm/trunk/UTIL/combine_plot_fields_single_open.f90	(revision 2696)
@@ -2,9 +2,10 @@
 
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms
-! of the GNU General Public License as published by the Free Software Foundation,
-! either version 3 of the License, or (at your option) any later version.
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
 !
 ! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
@@ -15,6 +16,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014  Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! Copyright 1997-2017  Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -40,5 +41,5 @@
 ! Vereinigung der von PARLES im Parallelbetrieb erzeugten Teilfelder zu
 ! gemeinsamen, das jeweilige Gesamtgebiet umfassenden Plotfeldern
-!-------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 
     IMPLICIT NONE
Index: palm/trunk/UTIL/compare_palm_logs.f90
===================================================================
--- palm/trunk/UTIL/compare_palm_logs.f90	(revision 2693)
+++ palm/trunk/UTIL/compare_palm_logs.f90	(revision 2696)
@@ -2,9 +2,10 @@
 
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms
-! of the GNU General Public License as published by the Free Software Foundation,
-! either version 3 of the License, or (at your option) any later version.
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
 !
 ! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
@@ -15,6 +16,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014  Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! Copyright 1997-2017  Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
Index: palm/trunk/UTIL/find_palm_config.f90
===================================================================
--- palm/trunk/UTIL/find_palm_config.f90	(revision 2693)
+++ palm/trunk/UTIL/find_palm_config.f90	(revision 2696)
@@ -2,9 +2,10 @@
 
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms
-! of the GNU General Public License as published by the Free Software Foundation,
-! either version 3 of the License, or (at your option) any later version.
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
 !
 ! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
@@ -15,6 +16,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014  Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! Copyright 1997-2017  Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
Index: palm/trunk/UTIL/inifor/Makefile
===================================================================
--- palm/trunk/UTIL/inifor/Makefile	(revision 2696)
+++ palm/trunk/UTIL/inifor/Makefile	(revision 2696)
@@ -0,0 +1,105 @@
+#------------------------------------------------------------------------------#
+# This file is part of PALM/PALM-4U.
+#
+# PALM/PALM-4U is free software: you can redistribute it and/or modify it under 
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation, either version 3 of the License, or (at your option) any later 
+# version.
+#
+# PALM/PALM-4U is distributed in the hope that it will be useful, but WITHOUT 
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# PALM. If not, see <http://www.gnu.org/licenses/>.
+#
+# Copyright 2017-2017 Leibniz Universitaet Hannover, Deutscher Wetterdienst
+# Offenbach
+#------------------------------------------------------------------------------#
+#
+# Current revisions:
+# -----------------
+# 
+# 
+# Former revisions:
+# -----------------
+# $Id$
+# Initial revision
+#
+# 
+#
+# Authors:
+# --------
+# @author Eckhard Kadasch
+#
+# Description:
+# ------------
+# This makefile may be used to exclusively compile INIFOR.
+#------------------------------------------------------------------------------#
+PROJECT = inifor
+PROJECT_PATH = .
+BIN_PATH  = $(PROJECT_PATH)/../../SCRIPTS
+SRC_PATH  = $(PROJECT_PATH)/src
+TEST_PATH = $(PROJECT_PATH)/tests
+
+MODULES = $(SRC_PATH)/defs.mod $(SRC_PATH)/util.mod $(SRC_PATH)/control.mod $(SRC_PATH)/types.mod $(SRC_PATH)/transform.mod $(SRC_PATH)/io.mod $(SRC_PATH)/grid.mod
+SOURCES = $(MODULES:%.mod=%.f90) $(SRC_PATH)/$(PROJECT).f90
+OBJECTS = $(SOURCES:%.f90=%.o)
+
+FC      = gfortran
+WRNGS   = -Wall -Wextra -Wsurprising -Waliasing -Wcharacter-truncation \
+		  -Wline-truncation -fbacktrace -fcheck=all -pedantic \
+		  -ffpe-trap=invalid,zero,underflow,overflow
+FFLAGS  = -fdefault-real-8 -Og -g $(WRNGS)
+INCLUDE = -I/home/ekadasch/local/include
+LIBRARY = -L/home/ekadasch/local/lib64 -lnetcdff
+
+.PHONY: all clean doc run tags test test-verbose $(PROJECT)
+
+$(PROJECT): $(OBJECTS) $(MODULES) tags
+	@echo ""
+	mkdir -p $(BIN_PATH)
+	$(FC) $(FFLAGS) $(OBJECTS) -o $(BIN_PATH)/$(PROJECT) -I$(SRC_PATH) $(LIBRARY)
+
+$(SRC_PATH)/%.o: $(SRC_PATH)/%.f90
+	@echo ""
+	$(FC) $(FFLAGS) -c $< -o $@ -J$(SRC_PATH) $(INCLUDE)
+
+$(SRC_PATH)/%.mod: $(SRC_PATH)/%.f90
+	@echo ""
+	$(FC) $(FFLAGS) -c $< -o $(@:%.mod=%.o) -J$(SRC_PATH) $(INCLUDE)
+
+all: clean $(PROJECT) test doc
+
+clean:
+	@echo ""
+	rm -rf $(OBJECTS) $(MODULES) $(BIN_PATH)/$(PROJECT)
+	rm -rf *.mod *.o
+	rm -rf ./doc/latex ./doc/html
+	rm -f $(SRC_PATH)/tags
+	rm -f *.files
+	rm -f palm-hsurf.nc
+	$(MAKE) -C $(TEST_PATH) clean
+	$(MAKE) -C $(SRC_PATH) clean
+
+doc:
+	@echo ""
+	doxygen ./doc/doxygen.config
+
+run: $(PROJECT)
+	@echo ""
+	$(BIN_PATH)/$(PROJECT)
+
+tags:
+	@echo ""
+	$(MAKE) -C $(SRC_PATH) tags
+
+test:
+	@echo "Running tests"
+	$(MAKE) -C $(TEST_PATH) test | grep Test
+	@echo "...done testing"
+
+test-verbose:
+	@echo "Running tests"
+	$(MAKE) -C $(TEST_PATH) test
+	@echo "...done testing"
